#pragma once

#include <rt/mpu.h>

#ifdef __cplusplus
extern "C" {
#endif

#if RT_MPU_ENABLE

#define RT_STACK_ALIGN(n) RT_MPU_ALIGN(n)

#if __ARM_ARCH == 6 || __ARM_ARCH == 7
#define RT_STACK_SIZE(n) RT_MPU_SIZE(n)
#endif

#endif // RT_MPU_ENABLE

// The Arm ABI specifies a minimum stack alignment of 8 bytes.
#ifndef RT_STACK_ALIGN
#define RT_STACK_ALIGN(n) 8UL
#endif

/* A register context takes 16-18 words depending on the architecture
 * subvariant. Pushing all callee-saved registers once requires an
 * additional 8 words. */
#ifndef RT_STACK_MIN
#define RT_STACK_MIN 128
#endif

/* With hardware floating-point, the context is larger by 34-36 words: 32 sp/16
 * dp registers, 1-3 floating-point state registers (fpscr on M and R, fpexc,
 * cpacr on R). */
#ifndef RT_STACK_FP_MIN
#ifdef __ARM_FP
#define RT_STACK_FP_MIN 384
#else
#define RT_STACK_FP_MIN RT_STACK_MIN
#endif // __ARM_FP
#endif // RT_STACK_FP_MIN

#ifdef __cplusplus
}
#endif
