#pragma once

/* The SW IRQ should be given the lowest priority.
 * Its ID is 129 on AM263x. Override it if needed. */
#ifndef RT_VIC_SW_IRQ
#define RT_VIC_SW_IRQ 129
#endif

#define RT_VIC_VIM_IRQVEC 0x50F00018
#define RT_VIC_VIM_GROUP 0x50F00400

#define RT_VIC_SW_IRQ_BITMASK (1U << (RT_VIC_SW_IRQ % 32))
#define RT_VIC_SW_IRQ_REG_OFFSET ((RT_VIC_SW_IRQ / 32) * 0x20)
#define RT_VIC_SW_IRQ_GROUP (RT_VIC_VIM_GROUP + RT_VIC_SW_IRQ_REG_OFFSET)

/* The Sitara VIM requires IRQ handler addresses to be 4-byte aligned, even if
 * they are thumb-encoded. (The least-significant 2 bits are ignored.) */
#define RT_VIC_IRQ_ALIGN 4

#ifndef __ASSEMBLER__

static inline void vic_syscall_pend(void)
{
    ((volatile uint32_t *)RT_VIC_SW_IRQ_GROUP)[0] = RT_VIC_SW_IRQ_BITMASK;
}

#endif
