#pragma once

// The C28x ABI specifies a minimum stack alignment of 2 words.
#define RT_STACK_ALIGN(n) 2UL

#define RT_STACK_SECTION(name) ".rt_task_stack:" #name

/*
 * A register context takes 34-36 words depending on the architecture
 * subvariant. Pushing all callee-saved registers once requires an additional 8
 * words. The system call handler will run on each task stack as well.
 */
#ifdef __TMS320C28XX_FPU32__
// The floating-point context is an additional 18 words.
#define RT_STACK_MIN 256UL
#else // !defined(__TMS320C28XX_FPU32__)
#define RT_STACK_MIN 128UL
#endif // __TMS320C28XX_FPU32__

#define RT_STACK_FP_MIN RT_STACK_MIN
