    .sect ".text:rt_syscall_handler"
    .global rt_syscall_handler
    .asmfunc
rt_syscall_handler:
    ; Re-enable interrupts. (This interrupt is masked still.)
    eint

    ; Push the remaining volatile context.
    push ar1h:ar0h
    push xar4
    push xar5
    push xar6
    push xar7
    push xt
    .if .TMS320C2800_FPU32
    push rb
    mov32 *sp++, r0h
    mov32 *sp++, r1h
    mov32 *sp++, r2h
    mov32 *sp++, r3h
    mov32 *sp++, stf
    .endif ; .TMS320C2800_FPU32

    asp
    spm 0
    clrc page0, ovm
    clrc amode
    .ref rt_syscall_run
    lcr rt_syscall_run
    nasp

    ; If there's no new context to switch to, return early.
    movl acc, xar4
    sb return?, eq

    ; Push the non-volatile context for the suspending task.
    push xar2
    push xar3
    push rpc

    .if .TMS320C2800_FPU32
    mov32 *sp++, r4h
    mov32 *sp++, r5h
    mov32 *sp++, r6h
    mov32 *sp++, r7h
    .endif ; .TMS320C2800_FPU32

    ; Store the new stack pointer with the saved context.
    .ref rt_context_prev
    movl xar6, #rt_context_prev
    movl xar6, *xar6
    mov al, sp
    mov *xar6, al

    ; Switch to the new task's stack.
    mov sp, ar4

    .if .TMS320C2800_FPU32
    mov32 r7h, *--sp
    mov32 r6h, *--sp
    mov32 r5h, *--sp
    mov32 r4h, *--sp
    .endif ; .TMS320C2800_FPU32

    pop rpc
    pop xar3
    pop xar2

return?:
    .if .TMS320C2800_FPU32
    mov32 stf, *--sp
    mov32 r3h, *--sp
    mov32 r2h, *--sp
    mov32 r1h, *--sp
    mov32 r0h, *--sp
    pop rb
    .endif ; .TMS320C2800_FPU32
    pop xt
    pop xar7
    pop xar6
    pop xar5
    pop xar4
    pop ar1h:ar0h

    dint ; Errata 4.1.2, caution while using nested interrupts.
    iret

    .endasmfunc


    .sect ".text:rt_start"
    .global rt_start
    .asmfunc
rt_start:
    .ref rt_start_context
    lcr rt_start_context

    mov sp, ar4

    .if .TMS320C2800_FPU32
    mov32 r7h, *--sp
    mov32 r6h, *--sp
    mov32 r5h, *--sp
    mov32 r4h, *--sp
    .endif ; .TMS320C2800_FPU32

    pop rpc
    pop xar3
    pop xar2

    .if .TMS320C2800_FPU32
    mov32 stf, *--sp
    mov32 r3h, *--sp
    mov32 r2h, *--sp
    mov32 r1h, *--sp
    mov32 r0h, *--sp
    pop rb
    .endif ; .TMS320C2800_FPU32
    pop xt
    pop xar7
    pop xar6
    pop xar5
    pop xar4
    pop ar1h:ar0h

    iret

    .endasmfunc
