#include <rt/cycle.h>
#include <rt/log.h>
#include <rt/sem.h>
#include <rt/task.h>
#include <rt/trap.h>

static volatile uint32_t start_cycle = 0;
static volatile uint32_t cycles = 0;

static RT_SEM(sem, 0);

static void poster(void)
{
    start_cycle = rt_cycle();
    rt_sem_post(&sem);
}

static void waiter(void)
{
    rt_sem_wait(&sem);
    cycles = rt_cycle() - start_cycle;
    rt_trap();
}

RT_TASK(poster, RT_STACK_MIN, 1);
RT_TASK(waiter, RT_STACK_MIN, 2);
