#include <rt/cycle.h>
#include <rt/log.h>
#include <rt/task.h>
#include <rt/trap.h>

static volatile uint32_t start_cycle = 0;
static volatile uint32_t cycles = 0;

static void task0(void)
{
    start_cycle = rt_cycle();
    rt_task_yield();
}

static void task1(void)
{
    cycles = rt_cycle() - start_cycle;
    rt_trap();
}

/* NOTE: Tasks of equal priority will initially be executed in the order they
 * are created. */
RT_TASK(task0, RT_STACK_MIN, 1);
RT_TASK(task1, RT_STACK_MIN, 1);
