#include <rt/task.h>

#include <rt/log.h>
#include <rt/syscall.h>

void rt_task_sleep(unsigned long ticks)
{
    if (ticks == 0)
    {
        return;
    }

    struct rt_syscall_record sleep_record;
    sleep_record.args.task_sleep.ticks = ticks;
    sleep_record.op = RT_SYSCALL_TASK_SLEEP;
    rt_logf("%s sleep for %lu ticks\n", rt_task_name(), ticks);
    rt_syscall_push(&sleep_record);
    rt_syscall();
}

void rt_task_sleep_periodic(unsigned long *last_wake_tick, unsigned long period)
{
    if (period == 0)
    {
        return;
    }

    struct rt_syscall_record sleep_record;
    sleep_record.args.task_sleep_periodic.last_wake_tick = *last_wake_tick;
    sleep_record.args.task_sleep_periodic.period = period;
    sleep_record.op = RT_SYSCALL_TASK_SLEEP_PERIODIC;
    rt_logf("%s sleep periodic, last wake = %lu, period = %lu\n",
            rt_task_name(), *last_wake_tick, period);
    *last_wake_tick += period;
    rt_syscall_push(&sleep_record);
    rt_syscall();
}
